;
; Ullrich von Bassewitz, 15.11.2002
;
; Original C code by Marc 'BlackJack' Rintsch, 25.03.2001
;
; int __fastcall__ cbm_write(unsigned char lfn, void* buffer, unsigned int size)
; {
;
;     static unsigned int byteswritten;
;
;     /* if we can't change to the outputchannel #lfn then return an error */
;     if (_oserror = cbm_k_ckout(lfn)) return -1;
;
;     byteswritten = 0;
;
;     while (byteswritten<size && !cbm_k_readst()) {
;         cbm_k_bsout(((unsigned char*)buffer)[byteswritten++]);
;     }
;
;     if (cbm_k_readst()) {
;         _oserror = 5;       /* device not present */
;         byteswritten = -1;
;     }
;
;     cbm_k_clrch();
;
;     return byteswritten;
; }
;

        .include        "cbm.inc"

       	.export	       	_bank1_cbm_write
        ;.import         CKOUT, READST, BSOUT, CLRCH
        .importzp       ptr1, ptr2, ptr3, ptr4, tmp1, tmp4
	.import	      	popax, popa
	.import	      	bank1_readbyteoffs2
        .import         __oserror
                                                   
;.importzp	bank_writeaddr
;.import	bank_write
.import		callkernal

_bank1_cbm_write:
        sta     ptr3
        stx     ptr3+1          ; Save size
        eor     #$FF
        sta     ptr4
        txa
        eor     #$FF
        sta     ptr4+1          ; Save -size-1

        jsr     popax
        sta     ptr1
        stx     ptr1+1          ; Save buffer

        jsr     popa
        ;tax
	;sta	tmp1
	tax
;Switch to Bank 15 for kernal access.
	;lda	$FF00
	;pha
	;lda	#$00
	;sta	$FF00
        ;jsr     CKOUT
	lda	#<CKOUT
	jsr	callkernal
        bcs     @E2             ; Branch on error
        bcc     @L2             ; Branch always

; Loop

@L1:
	lda	#<READST	
	jsr     callkernal
        cmp     #0              ; Status ok?
        bne     @E1
;pha
;lda	#'.'
;sta	tmp1
;lda	#$D2
;jsr	callkernal
;pla


        ldy     #0
	jsr	bank1_readbyteoffs2
        ;lda     (ptr2),y        ;
        inc     ptr1
        bne     @L2
        inc     ptr1+1          ; A = *buffer++;
@L2:    ;jsr     BSOUT           ; cbm_k_bsout (A);
	sta	tmp4
	;sta	tmp1
	lda	#<BSOUT
	jsr	callkernal

@L3:
	inc     ptr4            ; --size;
        bne     @L1
        inc     ptr4+1
        bne     @L1

	lda	#<CLRCH
        jsr     callkernal

        lda     ptr3
        ldx     ptr3+1          ; return size;

        rts

; Error entry, called when READST fails

@E1:    lda     #5

; Error entry, error code is in A

@E2:    sta     __oserror
        lda     #$FF
        tax
        rts                     ; return -1

