;Note: this is a modified version of the original file memset.s in cc65's common
;library by Ullrich von Bassewitz.
;-------------------------------------------------------------------------------
; void* __fastcall__ hmemset (void* ptr, int c, size_t n);
; void* __fastcall__ _hbzero (void* ptr, size_t n);
; void __fastcall__ hbzero (void* ptr, size_t n);
;
; Ullrich von Bassewitz, 29.05.1998
; Performance increase (about 20%) by
; Christian Krueger, 12.09.2009
;
; NOTE: bzero will return it's first argument as memset does. It is no problem
;       to declare the return value as void, since it may be ignored. _bzero
;       (note the leading underscore) is declared with the proper return type,
;       because the compiler will replace memset by _bzero if the fill value
;       is zero, and the optimizer looks at the return type to see if the value
;       in a/x is of any use.
;

 	.export		_bank1_memset, _bank1_bzero, __bank1_bzero
	.import		pusha, pushax, popax, _bank1_writebyte, _bank1_writeword
       	.importzp	sp, ptr1, ptr2, ptr3
	.importzp	tmp1, tmp2, tmp3 ;tmp1 and tmp2 imports by Harry Potter.

.import		bank1_writebytedirect

_bank1_bzero:
__bank1_bzero:
        sta     ptr3
        stx     ptr3+1          ; Save n
        lda     #0		; Fill with zeros
        beq     common

_bank1_memset:
 	sta	ptr3		; Save n
 	stx	ptr3+1
 	jsr	popax  	 	; Get c
	;tax

; Common stuff for memset and bzero from here

common:
;<---Changed by Harry Potter--->
	;stx	tmp1
	pha			;Preserve write value.
	ldy     #1
        lda     (sp),y
        sta	ptr1+1		; save high byte of ptr
        dey			; Y = 0
        lda     (sp),y          ; Get ptr
 	sta	ptr1
;Init. .A and .X for bank write.
	pla			;Retrieve write value.
;More than one page?
;(Last page if no.)
	ldy	ptr3+1
	beq	@lastpage
@pages:
	jsr	fillpage
	dec	ptr3+1		;Last page?
	bne	@pages+2	;If not, write next page.
	
@lastpage:
	ldy	#0		;Start last page.
@lastpage1:
	cpy	ptr3		;Exit if end.
	beq	@exit
	jsr	bank1_writebytedirect
	iny			;Advance.
	bne	@lastpage1
@exit:
	jmp	popax

.segment	"BANK1C"
fillpage:
	sta	$FF02
	sta	(ptr1),y
	iny
	bne	*-3
	sta	$FF01
	rts
	