;------------------------------------------------------------------------------
;
; C128 Bank1 memory routines.
;
; Written for cc65 by Joseph Rose.  If you find these routines useful, e-mail
; me.
;
; This module copies a data buffer between the two banks.
;
;------------------------------------------------------------------------------

.importzp	sp, ptr1, ptr2, regbank
.import		incsp6
.import		popax

;.importzp	bank_readaddr,	bank_writeaddr
;.import		bank_read,	bank_write
.import		bank1_readbyteoffs2, bank1_writebytedirect

.export		_bank1_memcpyto
.export		_bank1_memcpyfrom
.export		_bank1_memcpyin

.code
_bank1_memcpyto:
;Get length of block to copy.
	;jsr	popax
	sta	regbank
	stx	regbank+1
;Get source.
	jsr	popax
	sta	ptr2
	stx	ptr2+1
;Get destination.
	jsr	popax
	sta	ptr1
	stx	ptr1+1
;Set byte offset to 0 (direct pointers).
@copypage:
	lda	regbank+1
	beq	@lastpage
	ldy	#0
@copypagelp:
	lda	(ptr2),y
	jsr	bank1_writebytedirect
	iny
	bne	@copypagelp
	dec	regbank+1
	inc	ptr2+1
	inc	ptr2+1
	bne	@copypage
@lastpage:
	lda	regbank
	beq	@exit
	ldy	#0
@lastpagelp:
	lda	(ptr2),y
	jsr	bank1_writebytedirect
	iny
	cpy	regbank
	bcc	@lastpagelp
@exit:
	rts


_bank1_memcpyfrom:
;Get length of block to copy.
	;jsr	popax
	sta	regbank
	stx	regbank+1
;Get source.
	jsr	popax
	sta	ptr1
	stx	ptr1+1
;Get destination.
	jsr	popax
	sta	ptr2
	stx	ptr2+1
;Set byte offset to 0 (direct pointers).
@copypage:
	lda	regbank+1
	beq	@lastpage
	ldy	#0
@copypagelp:
	jsr	bank1_readbyteoffs2
	sta	(ptr2),y
	iny
	bne	@copypagelp
	dec	regbank+1
	inc	ptr1+1
	inc	ptr2+1
	bne	@copypage
@lastpage:
	lda	regbank
	beq	@exit
	ldy	#0
@lastpagelp:
	jsr	bank1_readbyteoffs2
	sta	(ptr2),y
	iny
	cpy	regbank
	bcc	@lastpagelp
@exit:
	rts




_bank1_memcpyin:
;Get length of block to copy.
	;jsr	popax
	sta	regbank
	stx	regbank+1
;Get source.
	jsr	popax
	sta	ptr1
	stx	ptr1+1
;Get destination.
	jsr	popax
	sta	ptr2
	stx	ptr2+1
;Set byte offset to 0 (direct pointers).
@copypage:
	lda	regbank+1
	beq	@lastpage
	ldy	#0
@copypagelp:
	jsr	bank1_copyinbyte
	iny
	bne	@copypagelp
	dec	regbank+1
	inc	ptr1+1
	inc	ptr2+1
	bne	@copypage
@lastpage:
	lda	regbank
	beq	@exit
	ldy	#0
@lastpagelp:
	lda	(ptr2),y
	jsr	bank1_copyinbyte
	iny
	cpy	regbank
	bcc	@lastpagelp
@exit:
	rts

.segment	"BANK1C"
bank1_copyinbyte:
	sta	$FF02
	lda	(ptr1),y
	sta	(ptr2),y
	sta	$FF01
	rts

