;----------------------------------------------------------------------------
;
; ca65 kernal call routine for MemBank128.
; 
; To use from assembler code:
;
; 1.  Pass the desired parameters in the .X and .Y registers and the carry
;     flag.
; 2.  Pass the desired accumulator, if any, in tmp4.
; 3.  Load the accumulator with the LSB of the entry address.  The MSB is
;     assumed to be $FF.
; 4.  Call this function (JSR callkernal).
; 5.  The registers and the carry flag will return data as usual.
;
;----------------------------------------------------------------------------

	.importzp	tmp4
	.export		callkernal

.segment	"LOWCODE"
callkernal:
	sta	@calladdr+1
	lda	#$00
	sta	$FF00
	lda	tmp4
@calladdr:
	jsr	$FF00
	sta	$FF01
	rts
